{*************************************************************************}
{*                                                                       *}
{*                  III Olimpiada Informatyczna                          *}
{*                                                                       *}
{*   Rozwiazanie zadania: HAZARD                                         *}
{*   Plik:                HAZ.PAS                                        *}
{*   Autor:               Wojciech Plandowski                            *}
{*************************************************************************}

program Hazard;
 const
  MaxLiczbaWierzcholkow=1000;
  PlikWe               ='HAZ.IN';
  PlikWy               ='HAZ.OUT';
 type
  ListaSasiadow      =^Sasiad;
  Sasiad             =record
                       NrSasiada :integer;
                       NastSasiad:ListaSasiadow
                      end;
  GrafMaszyny        =array[1..MaxLiczbaWierzcholkow] of ListaSasiadow;
  TablicaWierzcholkow=array[1..MaxLiczbaWierzcholkow] of integer;
 var
  Graf :GrafMaszyny;
  n    :integer;
  We,Wy:TablicaWierzcholkow;

 procedure WczytajGraf;
   {Wczytuje n i graf do tablicy Graf oraz oblicza tablice We i Wy}
  var
   f                        :text;
   i,j,LiczbaSasiadow,Sasiad:integer;
   s                        :ListaSasiadow;
 begin
  assign(f,PlikWe);  reset(f);
  readln(f,n);
   {inicjalizacja tablic We i Wy}
  for i:=1 to n do begin Wy[i]:=0;  We[i]:=0 end;
  for i:=1 to n do begin
   Graf[i]:=nil;
   read(f,LiczbaSasiadow);
   for j:=1 to LiczbaSasiadow do begin
    read(f,Sasiad);
    new(s);
    s^.NastSasiad:=Graf[i];
    s^.NrSasiada:=Sasiad;
    Graf[i]:=s;
    inc(Wy[i]);  inc(We[Sasiad])
   end; {for j }
   readln(f)
  end; {for i }
  close(f)
 end; {WczytajGraf}

 type
  StanyWierzcholkow=array[1..MaxLiczbaWierzcholkow]
                         of (Odwiedzony,NaDrodze,NieOdwiedzony);

 var
  JestCykl,WlozDoCyklu:boolean;
  KoniecCyklu         :integer;
  Cykl                :TablicaWierzcholkow;
  Stan                :StanyWierzcholkow;

 procedure Odwiedz(NrW:integer);
  var s:ListaSasiadow;
 begin
  Stan[NrW]:=NaDrodze;
  s:=Graf[NrW];
  while (s<>nil) and (not JestCykl) do
   if s^.NrSasiada<>n then begin {luk nie prowadzi do wierzcholka gn}
    if Stan[s^.NrSasiada]=NieOdwiedzony then Odwiedz(s^.NrSasiada)
    else if Stan[s^.NrSasiada]=NaDrodze then begin
          JestCykl:=true;
          KoniecCyklu:=s^.NrSasiada;
          WlozDoCyklu:=true
         end; {if Stan[... }
    if not JestCykl then s:=s^.NastSasiad
   end {if s^.NrSasiada<>n }
   else {pomin luk prowadzacy do wierzcholka gn}
    s:=s^.NastSasiad;
  Stan[Nrw]:=Odwiedzony;
  if WlozDoCyklu then begin
   Cykl[Nrw]:=s^.NrSasiada;
   WlozDoCyklu:=Nrw<>KoniecCyklu
  end {if}
 end; {Odwiedz}

 procedure UstawCyklPusty;
   {Wpisuje pusty cykl do tablicy Cykl}
  var i:integer;
 begin
  for i:=1 to n do Cykl[i]:=0
 end; {UstawCyklPusty}

 procedure ZnajdzCykl;
   {Znajduje cykl nie przechodzacy przez wierzcholek gn}
  var i:integer;
 begin
  JestCykl:=false;  WlozDoCyklu:=false;
  UstawCyklPusty;
  for i:=1 to n do Stan[i]:=NieOdwiedzony;
  i:=1;
  while (not JestCykl) and (i<=n-1) do begin
   if Stan[i]=NieOdwiedzony then Odwiedz(i);
   inc(i)
  end
 end; {ZnajdzCykl}

 function WarunekAlfa:boolean;
   {Sprawdza czy graf spelnia warunek alfa}
  var CzyAlfa:boolean; i:integer;
 begin
  CzyAlfa:=Wy[1]=We[1]+1;
  i:=2;
  while CzyAlfa and (i<=n-1) do begin
   CzyAlfa:=Wy[i]=We[i];
   inc(i)
  end;
  WarunekAlfa:=CzyAlfa and (Wy[n]+1=We[n])
 end; {WarunekAlfa}

 procedure WypiszNie;
   {Wypisuje NIE do pliku wyjsciowego}
  var f:text;
 begin
  assign(f,PlikWy);
  rewrite(f);
  write(f,'NIE');
  close(f)
 end; {WypiszNie}

 procedure WypiszPusta;
   {Wypisuje droge pusta do pliku wyjsciowego}
  var f:text;
 begin
  assign(f,PlikWy);
  rewrite(f);
  write(f,0);
  close(f)
 end; {WypiszPusta}

 procedure WypiszOmijajacCykl;
   {Konstruuje na slepo droge symulacyjna z lukow, ktore nie naleza
    do cyklu zapisanego w tablicy Cykl, wypisuje skonstruowana droge
    do pliku wyjsciowego.}
  var
   f       :text;
   Aktualny:ListaSasiadow;
   Nr      :integer;
 begin
  assign(f,PlikWy);
  rewrite(f);
  Nr:=1;
  while Graf[Nr]<>nil do begin
   if Cykl[Nr]=Graf[Nr]^.NrSasiada then {pomin luk cyklu}
    Graf[Nr]:=Graf[Nr]^.NastSasiad;
   Aktualny:=Graf[Nr];
   Graf[Nr]:=Graf[Nr]^.NastSasiad;
   Nr:=Aktualny^.NrSasiada;
   write(f,Nr,' ')
  end; {while Graf[Nr] }
  write(f,0);
  close(f)
 end; {WypiszOmijajacCykl}

begin  {Program glowny}
 WczytajGraf;
 if n<=1 then WypiszNie
 else
  if not WarunekAlfa then
    {Graf nie spelnia warunku alfa, wiec kazda droga symulacyjna
     jest wygrywajaca.}
   if Graf[1]<>nil then begin
    UstawCyklPusty;
    WypiszOmijajacCykl
   end
   else WypiszPusta
  else begin
   ZnajdzCykl;
   if JestCykl then WypiszOmijajacCykl
   else WypiszNie
  end {WarunekAlfa}
end. {Hazard}

